﻿package com.trick7.utils {
	import flash.display.*;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	/**
	* @author tera
	* サンプルコード（ドキュメントクラスとして設定すれば動きます）：
		package  {
			import flash.events.Event;
			import flash.display.Sprite;
			import com.trick7.utils.TeraClock;
			public class Main extends Sprite{
				public var clock:TeraClock;
				public function Main() {
					clock = new TeraClock();
					clock.addEventListener(TeraClock.SECONDS_CHANGED, secondsListener);
					clock.addEventListener(TeraClock.MINUTES_CHANGED, minutesListener);
					clock.addEventListener(TeraClock.HOURS_CHANGED, hoursListener);
				}
				private function secondsListener(e:Event):void {
					trace(clock.seconds + "秒です。現在：" +clock.hours+":"+clock.minutes+":"+clock.seconds+" です。" );
				}
				private function minutesListener(e:Event):void {
					trace(clock.minutes +"分になったよ。");
				}
				private function hoursListener(e:Event):void {
					trace(clock.hours+"時になったよ。");
				}
			}
		}
	*/
	public class TeraClock extends Sprite {
		public static const HOURS_CHANGED = "hoursChanged";
		public static const MINUTES_CHANGED = "minutesChanged";
		public static const SECONDS_CHANGED = "secondsChanged";
		private var _hours:int;
		private var _minutes:int;
		private var _seconds:int;
		private var _preSeconds:int;
		private var _gmt:int;
		// コンストラクタ関数。引数でタイムゾーンを設定できる。デフォルトは+9:00（日本）
		public function TeraClock(GMT:int = 9) {
			_gmt = GMT%24;
			addEventListener(Event.ENTER_FRAME, enterFrameListener);
		}
		
		private function enterFrameListener(e:Event):void {
			var date = new Date();
			if(_gmt>=0){
				_hours = (date.getUTCHours() + _gmt) % 24;
			}else {
				_hours = (24+(date.getUTCHours() + _gmt)) % 24;
			}
			_minutes = date.getUTCMinutes();
			_seconds = date.getUTCSeconds();
			if (_seconds != _preSeconds) {
				//trace(_hours + ":" + _minutes + ":" + _seconds);
				dispatchEvent(new Event(SECONDS_CHANGED));
				if (_seconds == 0) {
					dispatchEvent(new Event(MINUTES_CHANGED));
					if (_minutes == 0) {
						dispatchEvent(new Event(HOURS_CHANGED));
					}
				}
			}
			_preSeconds = _seconds;
		}
		// 外部から値を取得するためのゲッター。セッターはとりあえずいらないや。
		public function get hours():int { return _hours; }
		public function get minutes():int { return _minutes; }
		public function get seconds():int { return _seconds; }
		// 1桁の数の時を2桁にする。返り値は String 型になる。
		public function get hours2():String { return niketa(_hours); }
		public function get minutes2():String { return niketa(_minutes); }
		public function get seconds2():String { return niketa(_seconds); }
		// 2桁にして返す関数
		private function niketa(num:int):String {
			if (num < 10) {
				return String("0"+num);
			}else {
				return String(num);
			}
		}
	}
}